"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _withStyles = _interopRequireDefault(require("../withStyles"));

var _Button = _interopRequireDefault(require("../Button"));

var _MoreVert = _interopRequireDefault(require("elevate-ui-icons/MoreVert"));

var _SecondaryActions = _interopRequireDefault(require("./SecondaryActions"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Card = /*#__PURE__*/function (_Component) {
  _inherits(Card, _Component);

  var _super = _createSuper(Card);

  function Card(props) {
    var _this;

    _classCallCheck(this, Card);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "toggleSecondaryActions", function () {
      _this.setState(function (state) {
        return {
          menuActive: !state.menuActive
        };
      });
    });

    _this.state = {
      menuActive: false
    };
    return _this;
  }

  _createClass(Card, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          className = _this$props.className,
          title = _this$props.title,
          children = _this$props.children,
          icon = _this$props.icon,
          secondaryActions = _this$props.secondaryActions,
          actions = _this$props.actions;
      var menuActive = this.state.menuActive;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.root, className)
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.titleContainer
      }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.icon
      }, icon), " ", /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
        type: "heading6"
      }, title)), secondaryActions && secondaryActions.length > 0 ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("button", {
        className: classes.secondaryActionsButton,
        type: "button",
        onClick: this.toggleSecondaryActions
      }, /*#__PURE__*/_react["default"].createElement(_MoreVert["default"], null))) : null), /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.contentContainer
      }, children), /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.footerContainer
      }, actions.map(function (action) {
        return /*#__PURE__*/_react["default"].createElement(_Button["default"], {
          key: action.label,
          type: "button",
          className: classes.actionButton,
          onClick: action.onClick,
          icon: action.icon,
          isOutlined: action.isOutlined,
          color: action.color ? action.color : "primary"
        }, action.label);
      })), /*#__PURE__*/_react["default"].createElement(_SecondaryActions["default"], {
        handleClickOutside: this.toggleSecondaryActions,
        secondaryActions: secondaryActions,
        visible: menuActive
      }));
    }
  }]);

  return Card;
}(_react.Component);

var styles = function styles(theme) {
  return {
    root: {
      display: "flex",
      position: "relative",
      flexDirection: "column",
      width: "100%",
      maxWidth: "300px",
      border: "1px solid #ccc",
      borderRadius: "3px",
      backgroundColor: theme.colors["white"],
      boxShadow: theme.shadows[0]
    },
    titleContainer: {
      display: "flex",
      position: "relative",
      justifyContent: "space-between",
      alignItems: "center",
      padding: "8px",
      borderBottom: "1px solid ".concat(theme.colors["gray100"]),
      "& > div": {
        display: "flex",
        alignItems: "center"
      }
    },
    icon: {
      marginRight: "4px"
    },
    secondaryActionsButton: {
      appearance: "none",
      display: "flex",
      flexDirection: "column",
      justifyContent: "center",
      alignItems: "center",
      width: "40px",
      height: "40px"
    },
    contentContainer: {
      flex: "1 0 auto",
      padding: "8px"
    },
    footerContainer: {
      display: "flex",
      justifyContent: "center",
      alignItems: "center",
      padding: "8px",
      backgroundColor: theme.colors["gray050"],
      "& button + button": {
        marginLeft: "6px"
      }
    }
  };
};

var _default = (0, _withStyles["default"])(styles)(Card);

exports["default"] = _default;